﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Documents.Excel;
using System.IO;
using Infragistics.Win.UltraWinDataSource;

namespace WindowsFormsApplication3
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.LoadGridFromExcel();
        }

        private void LoadGridFromExcel()
        {
            string filename = "Book1.xlsx";
            Workbook workbook = Workbook.Load(filename);
            Worksheet worksheet = workbook.Worksheets[0];
            
            this.ultraDataSource1.Reset();

            bool isHeaderRow = true;
            foreach (WorksheetRow row in worksheet.Rows)
            {
                // Assume that the first row is the column headers. 
                if (isHeaderRow)
                {
                    foreach (WorksheetCell cell in row.Cells)
                    {
                        // Get the text of the cell. 
                        string columnKey = cell.GetText();

                        // Adda column
                        UltraDataColumn column = this.ultraDataSource1.Band.Columns.Add(columnKey);

                        // Set the DataType. 
                        switch (columnKey)
                        {
                            case "Name":
                                column.DataType = typeof(string);
                                break;
                            default:
                                column.DataType = typeof(double);
                                break;
                        }
                    }

                    // All following rows will not be headers. 
                    isHeaderRow = false;
                }
                else
                {
                    // Get the data fom the excel row cells. 
                    List<object> rowData = new List<object>();
                    foreach (WorksheetCell cell in row.Cells)
                    {
                        rowData.Add(cell.Value);
                    }

                    // Add a row to the UltraDataSource
                    this.ultraDataSource1.Rows.Add(rowData.ToArray());
                }
            }

            // Bind the UltraDataSource to the grid. 
            this.ultraGrid1.SetDataBinding(this.ultraDataSource1, "Band 0");
        }        
    }
}
